# line 2 "RtsFlags.lh"
#ifndef RTSFLAGS_H
#define RTSFLAGS_H
# line 9 "RtsFlags.lh"
struct GC_FLAGS {
    FILE   *statsFile;
    I_	    giveStats; 
#define NO_GC_STATS	 0
#define VERBOSE_GC_STATS 1

    I_	    stksSize; 
    I_	    heapSize; 
    I_	    allocAreaSize;
    rtsBool allocAreaSizeGiven;
    I_	    specifiedOldGenSize; 
    double  pcFreeHeap;
    I_	    minAllocAreaSize; 

    rtsBool force2s; 


    rtsBool forceGC; 
    I_	    forcingInterval; 
    rtsBool ringBell;
    W_	    trace;
	    






#define DEBUG_TRACE_MINOR_GC	 2
#define DEBUG_TRACE_MAJOR_GC	 4
#define DEBUG_TRACE_MARKING	 8
#define DEBUG_TRACE_FOREIGNOBJS 16
#define DEBUG_TRACE_CONCURRENT  32

    rtsBool lazyBlackHoling;
    rtsBool doSelectorsAtGC;
    rtsBool squeezeUpdFrames;
};

struct DEBUG_FLAGS {
};

#if defined(PROFILING) || defined(PAR)
    


struct COST_CENTRE_FLAGS {
    W_	    doCostCentres;
# define COST_CENTRES_SUMMARY	1
# define COST_CENTRES_VERBOSE	2 
# define COST_CENTRES_ALL	3

    char    sortBy;
# define SORTCC_LABEL	'C'
# define SORTCC_TIME 	'T'
# define SORTCC_ALLOC	'A'

    I_	    ctxtSwitchTicks; 
    I_	    profilerTicks;   
    I_	    msecsPerTick;    
};
#endif

#ifdef PROFILING
struct PROFILING_FLAGS {
    W_	doHeapProfile;
# define NO_HEAP_PROFILING	0	
# define HEAP_BY_CC		1
# define HEAP_BY_MOD		2
# define HEAP_BY_GRP		3
# define HEAP_BY_DESCR		4
# define HEAP_BY_TYPE		5
# define HEAP_BY_TIME		6
  
# define CCchar    'C'
# define MODchar   'M'
# define GRPchar   'G'
# define DESCRchar 'D'
# define TYPEchar  'Y'
# define TIMEchar  'T'

    char *ccSelector;
    char *modSelector;
    char *grpSelector;
    char *descrSelector;
    char *typeSelector;
    char *kindSelector;
};
#endif

#ifdef CONCURRENT
struct CONCURRENT_FLAGS {
    I_	    ctxtSwitchTime; 
    I_	    maxThreads;
    I_	    stkChunkSize;
    I_	    maxLocalSparks;
};
#endif 

#ifdef PAR
struct PAR_FLAGS {
    rtsBool parallelStats; 	
    rtsBool granSimStats;	
    rtsBool granSimStats_Binary;

    rtsBool outputDisabled;	
    
    W_	    packBufferSize;
};

#endif 

#ifdef GRAN
struct GRAN_FLAGS {
    rtsBool granSimStats;  
    rtsBool granSimStats_suppressed; 
    rtsBool granSimStats_Binary;
    rtsBool granSimStats_Sparks;
    rtsBool granSimStats_Heap;
    rtsBool labelling;
    W_	    packBufferSize;
    W_	    packBufferSize_internal;

    I_ proc;                      
    I_ max_fishes;                
    TIME time_slice;              

    
    W_ gran_latency;              
    W_ gran_additional_latency;   
    W_ gran_fetchtime;            
    W_ gran_lunblocktime;         
    W_ gran_gunblocktime;         
    W_ gran_mpacktime;                 
    W_ gran_munpacktime;	      
    W_ gran_mtidytime;		  

    W_ gran_threadcreatetime;     
    W_ gran_threadqueuetime;      
    W_ gran_threaddescheduletime; 
    W_ gran_threadscheduletime;   
    W_ gran_threadcontextswitchtime;  

    
    W_ gran_arith_cost;        
    W_ gran_branch_cost;        
    W_ gran_load_cost;         
    W_ gran_store_cost;        
    W_ gran_float_cost;        

    W_ gran_heapalloc_cost;    

    
    
    W_ gran_pri_spark_overhead;
    
    W_ gran_pri_sched_overhead;

    




   
    rtsBool Light;

    rtsBool DoFairSchedule ;        
    rtsBool DoReScheduleOnFetch ;   
    rtsBool DoStealThreadsFirst;    
    rtsBool SimplifiedFetch;        
    rtsBool DoAlwaysCreateThreads;  
    rtsBool DoGUMMFetching;         
    rtsBool DoThreadMigration;      
    I_      FetchStrategy;          
    rtsBool PreferSparksOfLocalNodes; 
    rtsBool DoPrioritySparking;     
    rtsBool DoPriorityScheduling;   
    I_      SparkPriority;          
    I_      SparkPriority2;
    rtsBool RandomPriorities;
    rtsBool InversePriorities;
    rtsBool IgnorePriorities;
    I_      ThunksToPack;            
    rtsBool RandomSteal;            
    rtsBool NoForward;              
    rtsBool PrintFetchMisses;       

    W_	    debug;
    rtsBool event_trace;
    rtsBool event_trace_all;
   
};
#endif 

#ifdef TICKY_TICKY
struct TICKY_FLAGS {
    rtsBool showTickyStats;
    FILE   *tickyFile;

    
};
#endif 
# line 215 "RtsFlags.lh"
struct RTS_FLAGS {
    struct GC_FLAGS	GcFlags;
    struct DEBUG_FLAGS	DebugFlags; 

#if defined(PROFILING) || defined(PAR)
    struct COST_CENTRE_FLAGS CcFlags;
#endif
#ifdef PROFILING
    struct PROFILING_FLAGS ProfFlags;
#endif
#ifdef CONCURRENT
    struct CONCURRENT_FLAGS ConcFlags;
#endif
#ifdef PAR
    struct PAR_FLAGS	ParFlags;
#endif
#ifdef GRAN
    struct GRAN_FLAGS	GranFlags;
#endif
#ifdef TICKY_TICKY
    struct TICKY_FLAGS	TickyFlags;
#endif
};

extern struct RTS_FLAGS RTSflags;
# line 244 "RtsFlags.lh"
void	initRtsFlagsDefaults (STG_NO_ARGS);
void	setupRtsFlags PROTO((int *argc,     char *argv[],
			     int *rts_argc, char *rts_argv[]));
# line 257 "RtsFlags.lh"
#define STATS_FILENAME_MAXLEN	128

#define GR_FILENAME_FMT		"%0.124s.gr"
#define GR_FILENAME_FMT_GUM	"%0.120s.%03d.%s"
#define HP_FILENAME_FMT		"%0.124s.hp"
#define LIFE_FILENAME_FMT	"%0.122s.life"
#define PROF_FILENAME_FMT	"%0.122s.prof"
#define PROF_FILENAME_FMT_GUM	"%0.118s.%03d.prof"
#define QP_FILENAME_FMT		"%0.124s.qp"
#define STAT_FILENAME_FMT	"%0.122s.stat"
#define TICKY_FILENAME_FMT	"%0.121s.ticky"
#define TIME_FILENAME_FMT	"%0.122s.time"
#define TIME_FILENAME_FMT_GUM	"%0.118s.%03d.time"
# line 274 "RtsFlags.lh"
#endif	
