# line 149 "SMInfoTables.lh"
#ifndef SMInfoTables_H
#define SMInfoTables_H
# line 154 "SMInfoTables.lh"
#ifdef __STG_REV_TBLS__

# define IREL(offset)	(-(offset))



# define ENTRY_CODE(infoptr)     ((F_)(infoptr))

#else 

# define IREL(offset)	(offset)

# define ENTRY_CODE(infoptr)     (((FP_)(infoptr))[IREL(0)])

#endif 
# line 172 "SMInfoTables.lh"
#define INFO_TAG(infoptr)	((I_) ((P_)(infoptr))[IREL(1)])
#define EVAL_TAG(infoptr)	(INFO_TAG(infoptr) >= 0)
# line 177 "SMInfoTables.lh"

#define INFO_INTERNAL		(~0L)	

#define INFO_UNUSED		(~0L)





# line 200 "SMInfoTables.lh"
#if defined(COMPILING_REP_LC) || defined(COMPILING_GHC)
# define MAYBE_DECLARE_RTBL(l,s,p)
#else
# define MAYBE_DECLARE_RTBL(l,s,p)	EXTDATA_RO(MK_REP_REF(l,s,p));
#endif

#define INFO_RTBL(infoptr)	(((PP_)(infoptr))[IREL(2)])
# line 218 "SMInfoTables.lh"
#define FIXED_INFO_WORDS		3
# line 230 "SMInfoTables.lh"
#define PROFILING_INFO_OFFSET  (FIXED_INFO_WORDS)

#if !defined(PROFILING)
# define PROFILING_INFO_WORDS	0
# define INCLUDE_PROFILING_INFO(base_name)
# define INREGS_PROFILING_INFO    

#else
# define PROFILING_INFO_WORDS 	1

# define INCLUDE_PROFILING_INFO(base_name) , (W_)REF_CAT_IDENT(base_name)
# define INREGS_PROFILING_INFO	,INFO_UNUSED

# define INFO_CAT(infoptr)  (((ClCategory *)(infoptr))[IREL(PROFILING_INFO_OFFSET)])

#endif
# line 276 "SMInfoTables.lh"

#define UPDATE_INFO_OFFSET  (PROFILING_INFO_OFFSET+PROFILING_INFO_WORDS)

#ifndef PAR
# define UPDATE_INFO_WORDS    1
# define INCLUDE_UPDATE_INFO(upd,live)	,(W_)upd
#else
# define UPDATE_INFO_WORDS    2
# define INCLUDE_UPDATE_INFO(upd,live)	,(W_)upd,(W_)live
#endif

#define UPDATE_CODE(infoptr)	(((FP_)(infoptr))[IREL(UPDATE_INFO_OFFSET)])
#define INFO_LIVENESS(infoptr)	(((P_)(infoptr))[IREL(UPDATE_INFO_OFFSET+1)])
# line 298 "SMInfoTables.lh"
#define GEN_INFO_OFFSET	    (UPDATE_INFO_OFFSET+UPDATE_INFO_WORDS)
#define GEN_INFO_WORDS    2
#define INCLUDE_GEN_INFO(size,ptrs)	,(W_)size,(W_)ptrs

#define GEN_INFO_SIZE(infoptr)	 ((I_)((P_)(infoptr))[IREL(GEN_INFO_OFFSET)])
#define GEN_INFO_NoPTRS(infoptr) ((I_)((P_)(infoptr))[IREL(GEN_INFO_OFFSET+1)])
# line 310 "SMInfoTables.lh"
#define CONST_INFO_OFFSET	    (UPDATE_INFO_OFFSET+UPDATE_INFO_WORDS)
#define CONST_INFO_WORDS    1
#define INCLUDE_CONST_INFO(closure)	,(W_)closure

#define CONST_STATIC_CLOSURE(infoptr)	(((PP_)(infoptr))[IREL(CONST_INFO_OFFSET)])
# line 323 "SMInfoTables.lh"
#define STATIC_INFO_OFFSET	    (UPDATE_INFO_OFFSET+UPDATE_INFO_WORDS)
#define STATIC_INFO_WORDS    2
#define INCLUDE_STATIC_INFO(size,ptrs)	,(W_)size,(W_)ptrs

#define STATIC_INFO_SIZE(infoptr)   ((I_)((P_)(infoptr))[IREL(STATIC_INFO_OFFSET)])
#define STATIC_INFO_NoPTRS(infoptr) ((I_)((P_)(infoptr))[IREL(STATIC_INFO_OFFSET+1)])
# line 339 "SMInfoTables.lh"
#if defined(PAR) || defined(GRAN)
# define RBH_INFO_OFFSET	    (GEN_INFO_OFFSET+GEN_INFO_WORDS)

# define INCLUDE_SPEC_PADDING				\
	INCLUDE_UPDATE_INFO(INFO_UNUSED,INFO_UNUSED)	\
	INCLUDE_GEN_INFO(INFO_UNUSED,INFO_UNUSED)

# ifdef RBH_MAGIC_OFFSET

#  define RBH_INFO_WORDS    0
#  define INCLUDE_RBH_INFO(infoptr)

#  define RBH_INFOPTR(infoptr)	    (((P_)infoptr) - RBH_MAGIC_OFFSET)
#  define REVERT_INFOPTR(infoptr)   (((P_)infoptr) + RBH_MAGIC_OFFSET)

# else

#  define RBH_INFO_WORDS    1
#  define INCLUDE_RBH_INFO(infoptr) ,(W_)infoptr

#  define RBH_INFOPTR(infoptr)	    (((PP_)(infoptr))[IREL(RBH_INFO_OFFSET)])
#  define REVERT_INFOPTR(infoptr)   (((PP_)(infoptr))[IREL(RBH_INFO_OFFSET)])

# endif

EXTFUN(RBH_entry);
P_ convertToRBH PROTO((P_ closure));
#if defined(GRAN)
void convertFromRBH PROTO((P_ closure));
#elif defined(PAR)
void convertToFetchMe PROTO((P_ closure, globalAddr *ga));
#endif

#endif
# line 391 "SMInfoTables.lh"
#define TYPE_INFO_OFFSET  0
#define TYPE_INFO_WORDS    1
#define INCLUDE_TYPE_INFO(kind) (W_)CAT3(INFO_,kind,_TYPE)

#define INFO_TYPE(infoptr)	(((P_)(INFO_RTBL(infoptr)))[TYPE_INFO_OFFSET])
# line 422 "SMInfoTables.lh"
#define	IP_TAG_BITS		9

#define _NF			0x0001  
#define _NS			0x0002	
#define _ST			0x0004	
#define _MU 	    	    	0x0008  
#define _UP			0x0010	
#define _BM			0x0020	
#define _BH			0x0040	
#define _IN			0x0080	
#define _TH			0x0100	

#define	IS_NF(infoptr)		((INFO_TYPE(infoptr)&_NF) != 0)
#define	IS_MUTABLE(infoptr)	((INFO_TYPE(infoptr)&_MU) != 0)
#define	IS_STATIC(infoptr)	((INFO_TYPE(infoptr)&_ST) != 0)
#define	IS_UPDATABLE(infoptr)	((INFO_TYPE(infoptr)&_UP) != 0)
#define	IS_BIG_MOTHER(infoptr)	((INFO_TYPE(infoptr)&_BM) != 0)
#define IS_BLACK_HOLE(infoptr)	((INFO_TYPE(infoptr)&_BH) != 0)
#define IS_INDIRECTION(infoptr)	((INFO_TYPE(infoptr)&_IN) != 0)
#define IS_THUNK(infoptr)	((INFO_TYPE(infoptr)&_TH) != 0)

#define	SHOULD_SPARK(closure)	((INFO_TYPE(INFO_PTR(closure))&_NS) == 0)
# line 450 "SMInfoTables.lh"
#define	IP_TAG_BIT_MASK		((1L<<IP_TAG_BITS)-1)

#define BASE_INFO_TYPE(infoptr)	(INFO_TYPE(infoptr) & (~IP_TAG_BIT_MASK)) 

#define MAKE_BASE_INFO_TYPE(x)	((x) << IP_TAG_BITS)

#define INFO_SPEC_TYPE		(MAKE_BASE_INFO_TYPE(1L))
#define INFO_GEN_TYPE		(MAKE_BASE_INFO_TYPE(2L))
#define INFO_DYN_TYPE		(MAKE_BASE_INFO_TYPE(3L) | _NF | _NS)
#define INFO_TUPLE_TYPE		(MAKE_BASE_INFO_TYPE(4L) | _NF | _NS | _BM)
#define INFO_DATA_TYPE		(MAKE_BASE_INFO_TYPE(5L) | _NF | _NS | _BM)
#define INFO_MUTUPLE_TYPE	(MAKE_BASE_INFO_TYPE(6L) | _NF | _NS | _MU | _BM)
#define INFO_IMMUTUPLE_TYPE	(MAKE_BASE_INFO_TYPE(7L) | _NF | _NS | _BM)
#define INFO_STATIC_TYPE	(MAKE_BASE_INFO_TYPE(8L) | _NS | _ST)
#define INFO_CONST_TYPE		(MAKE_BASE_INFO_TYPE(9L) | _NF | _NS)
#define INFO_CHARLIKE_TYPE	(MAKE_BASE_INFO_TYPE(10L) | _NF | _NS)
#define INFO_INTLIKE_TYPE	(MAKE_BASE_INFO_TYPE(11L) | _NF | _NS)
#define INFO_BH_TYPE		(MAKE_BASE_INFO_TYPE(12L) | _NS | _BH)
#define INFO_BQ_TYPE		(MAKE_BASE_INFO_TYPE(13L) | _NS | _MU | _BH)
#define INFO_IND_TYPE		(MAKE_BASE_INFO_TYPE(14L) | _NS | _IN)
#define INFO_CAF_TYPE		(MAKE_BASE_INFO_TYPE(15L) | _NF | _NS | _ST | _IN)
#define INFO_FM_TYPE		(MAKE_BASE_INFO_TYPE(16L))
#define INFO_TSO_TYPE		(MAKE_BASE_INFO_TYPE(17L) | _MU)
#define INFO_STKO_TYPE		(MAKE_BASE_INFO_TYPE(18L))
#define INFO_SPEC_RBH_TYPE	(MAKE_BASE_INFO_TYPE(19L) | _NS | _MU | _BH)
#define INFO_GEN_RBH_TYPE	(MAKE_BASE_INFO_TYPE(20L) | _NS | _MU | _BH)
#define INFO_BF_TYPE		(MAKE_BASE_INFO_TYPE(21L) | _NS | _MU | _BH)
#define INFO_INTERNAL_TYPE	(MAKE_BASE_INFO_TYPE(22L))

#define INFO_SPEC_N_TYPE	(INFO_SPEC_TYPE | _NF | _NS)
#define INFO_SPEC_S_TYPE	(INFO_SPEC_TYPE | _TH)
#define INFO_SPEC_U_TYPE	(INFO_SPEC_TYPE | _UP | _TH)

#define INFO_GEN_N_TYPE		(INFO_GEN_TYPE | _NF | _NS)
#define INFO_GEN_S_TYPE		(INFO_GEN_TYPE | _TH)
#define INFO_GEN_U_TYPE		(INFO_GEN_TYPE | _UP | _TH)

#define INFO_BH_N_TYPE		(INFO_BH_TYPE)
#define INFO_BH_U_TYPE		(INFO_BH_TYPE | _UP)

#define INFO_STKO_DYNAMIC_TYPE	(INFO_STKO_TYPE | _MU)
#define INFO_STKO_STATIC_TYPE	(INFO_STKO_TYPE | _ST)

#define INFO_FETCHME_TYPE	(INFO_FM_TYPE | _MU)
#define INFO_FMBQ_TYPE		(INFO_FM_TYPE | _MU | _BH)

#define MIN_INFO_TYPE		0
#define MAX_INFO_TYPE		INFO_INTERNAL_TYPE

# line 514 "SMInfoTables.lh"
#define SIZE_INFO_OFFSET  (TYPE_INFO_OFFSET+TYPE_INFO_WORDS)
#define SIZE_INFO_WORDS	  2
#define INCLUDE_SIZE_INFO(size,ptrs) ,(W_)size, (W_)ptrs

#define INFO_SIZE(infoptr)   ((I_)((FP_)(INFO_RTBL(infoptr)))[SIZE_INFO_OFFSET])
#define INFO_NoPTRS(infoptr) ((I_)((FP_)(INFO_RTBL(infoptr)))[SIZE_INFO_OFFSET+1])
# line 532 "SMInfoTables.lh"
# define PAR_INFO_OFFSET		(SIZE_INFO_OFFSET+SIZE_INFO_WORDS)



# define PAR_INFO_WORDS		0
# define INCLUDE_PAR_INFO
# line 549 "SMInfoTables.lh"
#if defined(_INFO_COPYING)
# include "SMcopying.h" 
# define COPY_INFO_OFFSET  (PAR_INFO_OFFSET+PAR_INFO_WORDS)
# define COPY_INFO_WORDS 2
# define INCLUDE_COPYING_INFO(evac, scav) ,(W_)evac,(W_)scav






# define INFO_EVAC_2S(infoptr)  (((FP_)(INFO_RTBL(infoptr)))[COPY_INFO_OFFSET])
# define INFO_SCAV_2S(infoptr)  (((FP_)(INFO_RTBL(infoptr)))[COPY_INFO_OFFSET + 1])

#else  

# define COPY_INFO_WORDS 0
# define INCLUDE_COPYING_INFO(evac, scav)

#endif 
# line 582 "SMInfoTables.lh"
#if !defined(_INFO_COMPACTING)

# define INCLUDE_COMPACTING_INFO(scanlink,prmark,scanmove,marking)
# define SPEC_COMPACTING_INFO(scanlink,prmark,scanmove,marking)

#else 

# include "SMcompact.h" 	
# include "SMmark.h"    	



# define COMPACTING_INFO_OFFSET  (COPY_INFO_OFFSET+COPY_INFO_WORDS)

# define INCLUDE_COMPACTING_INFO(scanlink,prmark,scanmove,marking) \
	,(W_)scanlink,(W_)prmark \
	,(W_)scanmove,(W_)marking

# define SPEC_COMPACTING_INFO(scanlink,prmark,scanmove,prreturn) \
	,(W_)scanlink,(W_)prmark \
	,(W_)scanmove, \
	 (W_)prreturn


# define INFO_SCAN_LINK_1S(infoptr)  	(((FP_)(INFO_RTBL(infoptr)))[COMPACTING_INFO_OFFSET])
# define INFO_MARK_1S(infoptr)  	(((FP_)(INFO_RTBL(infoptr)))[COMPACTING_INFO_OFFSET+1])
# define INFO_SCAN_MOVE_1S(infoptr)  	(((FP_)(INFO_RTBL(infoptr)))[COMPACTING_INFO_OFFSET+2])
# define INFO_MARKED_1S(infoptr)  	(((FP_)(INFO_RTBL(infoptr)))[COMPACTING_INFO_OFFSET+3])
# define INFO_MARKING_1S(infoptr)  	(((FP_)(INFO_RTBL(infoptr)))[COMPACTING_INFO_OFFSET+4])

#ifndef COMPILING_GHC
extern F_ _Dummy_Static_entry(STG_NO_ARGS);
extern F_ _Dummy_Ind_entry(STG_NO_ARGS);
extern F_ _Dummy_Caf_entry(STG_NO_ARGS);
extern F_ _Dummy_Const_entry(STG_NO_ARGS);
extern F_ _Dummy_CharLike_entry(STG_NO_ARGS);
#endif

#endif 
# line 632 "SMInfoTables.lh"

#define SPEC_N_ITBL(infolbl,entry_code,upd_code,liveness,tag,size,ptrs,localness,entry_localness,kind,descr,type) \
    CAT_DECLARE(infolbl,kind,descr,type) 	\
    entry_localness(entry_code);	    	\
    localness W_ infolbl[] = {			\
        (W_) entry_code				\
	,(W_) tag			        \
	,(W_) MK_REP_REF(Spec_N,size,ptrs)	\
	INCLUDE_PROFILING_INFO(infolbl)		\
	INCLUDE_UPDATE_INFO(upd_code,liveness)	\
	}

MAYBE_DECLARE_RTBL(Spec_N,1,0)
MAYBE_DECLARE_RTBL(Spec_N,1,1)
MAYBE_DECLARE_RTBL(Spec_N,2,0)
MAYBE_DECLARE_RTBL(Spec_N,2,1)
MAYBE_DECLARE_RTBL(Spec_N,2,2)
MAYBE_DECLARE_RTBL(Spec_N,3,0)
MAYBE_DECLARE_RTBL(Spec_N,3,1)
MAYBE_DECLARE_RTBL(Spec_N,3,2)
MAYBE_DECLARE_RTBL(Spec_N,3,3)
MAYBE_DECLARE_RTBL(Spec_N,4,0)
MAYBE_DECLARE_RTBL(Spec_N,4,4)
MAYBE_DECLARE_RTBL(Spec_N,5,0)
MAYBE_DECLARE_RTBL(Spec_N,5,5)
MAYBE_DECLARE_RTBL(Spec_N,6,6)
MAYBE_DECLARE_RTBL(Spec_N,7,7)
MAYBE_DECLARE_RTBL(Spec_N,8,8)
MAYBE_DECLARE_RTBL(Spec_N,9,9)
MAYBE_DECLARE_RTBL(Spec_N,10,10)
MAYBE_DECLARE_RTBL(Spec_N,11,11)
MAYBE_DECLARE_RTBL(Spec_N,12,12)

#define SPEC_N_RTBL(size,ptrs) 							\
    const W_ MK_REP_LBL(Spec_N,size,ptrs)[] = {					\
	INCLUDE_TYPE_INFO(SPEC_N)						\
	INCLUDE_SIZE_INFO(size,ptrs)						\
	INCLUDE_PAR_INFO							\
	INCLUDE_COPYING_INFO(CAT2(_Evacuate_,size),CAT4(_Scavenge_,size,_,ptrs)) \
	SPEC_COMPACTING_INFO(CAT4(_ScanLink_,size,_,ptrs),			\
			     CAT2(_PRStart_,ptrs),				\
			     CAT2(_ScanMove_,size),CAT2(_PRIn_,ptrs))		\
	}

#define SPEC_S_ITBL(infolbl,entry_code,upd_code,liveness,tag,size,ptrs,localness,entry_localness,kind,descr,type) \
    CAT_DECLARE(infolbl,kind,descr,type) 	\
    entry_localness(entry_code);	    	\
    localness W_ infolbl[] = {			\
        (W_) entry_code				\
	,(W_) tag			        \
	,(W_) MK_REP_REF(Spec_S,size,ptrs)	\
	INCLUDE_PROFILING_INFO(infolbl)		\
	INCLUDE_UPDATE_INFO(upd_code,liveness)	\
	}

MAYBE_DECLARE_RTBL(Spec_S,1,0)
MAYBE_DECLARE_RTBL(Spec_S,1,1)
MAYBE_DECLARE_RTBL(Spec_S,2,0)
MAYBE_DECLARE_RTBL(Spec_S,2,1)
MAYBE_DECLARE_RTBL(Spec_S,2,2)
MAYBE_DECLARE_RTBL(Spec_S,3,0)
MAYBE_DECLARE_RTBL(Spec_S,3,1)
MAYBE_DECLARE_RTBL(Spec_S,3,2)
MAYBE_DECLARE_RTBL(Spec_S,3,3)
MAYBE_DECLARE_RTBL(Spec_S,4,0)
MAYBE_DECLARE_RTBL(Spec_S,4,4)
MAYBE_DECLARE_RTBL(Spec_S,5,0)
MAYBE_DECLARE_RTBL(Spec_S,5,5)
MAYBE_DECLARE_RTBL(Spec_S,6,6)
MAYBE_DECLARE_RTBL(Spec_S,7,7)
MAYBE_DECLARE_RTBL(Spec_S,8,8)
MAYBE_DECLARE_RTBL(Spec_S,9,9)
MAYBE_DECLARE_RTBL(Spec_S,10,10)
MAYBE_DECLARE_RTBL(Spec_S,11,11)
MAYBE_DECLARE_RTBL(Spec_S,12,12)

#define SPEC_S_RTBL(size,ptrs) 							\
    const W_ MK_REP_LBL(Spec_S,size,ptrs)[] = {					\
	INCLUDE_TYPE_INFO(SPEC_S)						\
	INCLUDE_SIZE_INFO(size,ptrs)						\
	INCLUDE_PAR_INFO							\
	INCLUDE_COPYING_INFO(CAT2(_Evacuate_,size),CAT4(_Scavenge_,size,_,ptrs)) \
	SPEC_COMPACTING_INFO(CAT4(_ScanLink_,size,_,ptrs),			\
			     CAT2(_PRStart_,ptrs),				\
			     CAT2(_ScanMove_,size),CAT2(_PRIn_,ptrs))		\
	}

#if defined(PAR) || defined(GRAN)
# define SPEC_U_ITBL(infolbl,entry_code,upd_code,liveness,tag,size,ptrs,localness,entry_localness,kind,descr,type) \
    entry_localness(CAT2(RBH_,entry_code));    	\
    localness W_ infolbl[];			\
     localness W_ CAT2(RBH_,infolbl)[] = {	\
        (W_) CAT2(RBH_,entry_code)		\
	,(W_) INFO_OTHER_TAG			\
	,(W_) MK_REP_REF(Spec_RBH,size,ptrs)	\
	INCLUDE_PROFILING_INFO(RBH)		\
	INCLUDE_SPEC_PADDING			\
	INCLUDE_RBH_INFO(infolbl)		\
	};					\
    STGFUN(CAT2(RBH_,entry_code)) { JMP_(RBH_entry); }\
    CAT_DECLARE(infolbl,kind,descr,type) 	\
    entry_localness(entry_code);	    	\
    localness W_ infolbl[] = {			\
        (W_) entry_code				\
	,(W_) tag				\
	,(W_) MK_REP_REF(Spec_U,size,ptrs)	\
	INCLUDE_PROFILING_INFO(infolbl)		\
	INCLUDE_SPEC_PADDING			\
	INCLUDE_RBH_INFO(CAT2(RBH_,infolbl))	\
	}

MAYBE_DECLARE_RTBL(Spec_RBH,1,0)
MAYBE_DECLARE_RTBL(Spec_RBH,1,1)
MAYBE_DECLARE_RTBL(Spec_RBH,2,0)
MAYBE_DECLARE_RTBL(Spec_RBH,2,1)
MAYBE_DECLARE_RTBL(Spec_RBH,2,2)
MAYBE_DECLARE_RTBL(Spec_RBH,3,0)
MAYBE_DECLARE_RTBL(Spec_RBH,3,1)
MAYBE_DECLARE_RTBL(Spec_RBH,3,2)
MAYBE_DECLARE_RTBL(Spec_RBH,3,3)
MAYBE_DECLARE_RTBL(Spec_RBH,4,0)
MAYBE_DECLARE_RTBL(Spec_RBH,4,4)
MAYBE_DECLARE_RTBL(Spec_RBH,5,0)
MAYBE_DECLARE_RTBL(Spec_RBH,5,5)
MAYBE_DECLARE_RTBL(Spec_RBH,6,6)
MAYBE_DECLARE_RTBL(Spec_RBH,7,7)
MAYBE_DECLARE_RTBL(Spec_RBH,8,8)
MAYBE_DECLARE_RTBL(Spec_RBH,9,9)
MAYBE_DECLARE_RTBL(Spec_RBH,10,10)
MAYBE_DECLARE_RTBL(Spec_RBH,11,11)
MAYBE_DECLARE_RTBL(Spec_RBH,12,12)

#define SPEC_RBH_RTBL(size,ptrs)						\
    const W_ MK_REP_LBL(Spec_RBH,size,ptrs)[] = {				\
	INCLUDE_TYPE_INFO(SPEC_RBH)			    			\
	INCLUDE_SIZE_INFO(size,ptrs)						\
	INCLUDE_PAR_INFO							\
	INCLUDE_COPYING_INFO(CAT2(_Evacuate_RBH_,size),CAT4(_Scavenge_RBH_,size,_,ptrs)) \
	SPEC_COMPACTING_INFO(CAT4(_ScanLink_RBH_,size,_,ptrs),			\
			     CAT2(_PRStart_RBH_,ptrs),				\
			     CAT2(_ScanMove_RBH_,size),CAT2(_PRIn_RBH_,ptrs))	\
	}

#define _Scavenge_RBH_2_0   _Scavenge_RBH_2_1
#define _Scavenge_RBH_2_2   _Scavenge_RBH_2_1

#define _Scavenge_RBH_3_0   _Scavenge_RBH_3_1
#define _Scavenge_RBH_3_2   _Scavenge_RBH_3_1

#define _Scavenge_RBH_4_0   _Scavenge_RBH_4_1
#define _Scavenge_RBH_5_0   _Scavenge_RBH_5_1
#define _Scavenge_RBH_6_0   _Scavenge_RBH_6_1
#define _Scavenge_RBH_7_0   _Scavenge_RBH_7_1
#define _Scavenge_RBH_8_0   _Scavenge_RBH_8_1
#define _Scavenge_RBH_9_0   _Scavenge_RBH_9_1
#define _Scavenge_RBH_10_0   _Scavenge_RBH_10_1
#define _Scavenge_RBH_11_0   _Scavenge_RBH_11_1
#define _Scavenge_RBH_12_0   _Scavenge_RBH_12_1

#define _ScanLink_RBH_2_0   _ScanLink_RBH_2_1
#define _ScanLink_RBH_2_2   _ScanLink_RBH_2_1

#define _ScanLink_RBH_3_0   _ScanLink_RBH_3_1
#define _ScanLink_RBH_3_2   _ScanLink_RBH_3_1

#define _ScanLink_RBH_4_0   _ScanLink_RBH_4_1
#define _ScanLink_RBH_5_0   _ScanLink_RBH_5_1
#define _ScanLink_RBH_6_0   _ScanLink_RBH_6_1
#define _ScanLink_RBH_7_0   _ScanLink_RBH_7_1
#define _ScanLink_RBH_8_0   _ScanLink_RBH_8_1
#define _ScanLink_RBH_9_0   _ScanLink_RBH_9_1
#define _ScanLink_RBH_10_0   _ScanLink_RBH_10_1
#define _ScanLink_RBH_11_0   _ScanLink_RBH_11_1
#define _ScanLink_RBH_12_0   _ScanLink_RBH_12_1

#define _PRStart_RBH_0	_PRStart_RBH_2
#define _PRStart_RBH_1	_PRStart_RBH_2

#define _PRIn_RBH_0	_PRIn_RBH_2
#define _PRIn_RBH_1	_PRIn_RBH_2

#else

# define SPEC_U_ITBL(infolbl,entry_code,upd_code,liveness,tag,size,ptrs,localness,entry_localness,kind,descr,type) \
    CAT_DECLARE(infolbl,kind,descr,type) 	\
    entry_localness(entry_code);	    	\
    localness W_ infolbl[] = {			\
        (W_) entry_code				\
	,(W_) tag				\
	,(W_) MK_REP_REF(Spec_U,size,ptrs)	\
	INCLUDE_PROFILING_INFO(infolbl)		\
	}
#endif

MAYBE_DECLARE_RTBL(Spec_U,1,0)
MAYBE_DECLARE_RTBL(Spec_U,1,1)
MAYBE_DECLARE_RTBL(Spec_U,2,0)
MAYBE_DECLARE_RTBL(Spec_U,2,1)
MAYBE_DECLARE_RTBL(Spec_U,2,2)
MAYBE_DECLARE_RTBL(Spec_U,3,0)
MAYBE_DECLARE_RTBL(Spec_U,3,1)
MAYBE_DECLARE_RTBL(Spec_U,3,2)
MAYBE_DECLARE_RTBL(Spec_U,3,3)
MAYBE_DECLARE_RTBL(Spec_U,4,0)
MAYBE_DECLARE_RTBL(Spec_U,4,4)
MAYBE_DECLARE_RTBL(Spec_U,5,0)
MAYBE_DECLARE_RTBL(Spec_U,5,5)
MAYBE_DECLARE_RTBL(Spec_U,6,6)
MAYBE_DECLARE_RTBL(Spec_U,7,7)
MAYBE_DECLARE_RTBL(Spec_U,8,8)
MAYBE_DECLARE_RTBL(Spec_U,9,9)
MAYBE_DECLARE_RTBL(Spec_U,10,10)
MAYBE_DECLARE_RTBL(Spec_U,11,11)
MAYBE_DECLARE_RTBL(Spec_U,12,12)

#define SPEC_U_RTBL(size,ptrs)							\
    const W_ MK_REP_LBL(Spec_U,size,ptrs)[] = {					\
	INCLUDE_TYPE_INFO(SPEC_U)			    			\
	INCLUDE_SIZE_INFO(size,ptrs)						\
	INCLUDE_PAR_INFO							\
	INCLUDE_COPYING_INFO(CAT2(_Evacuate_,size),CAT4(_Scavenge_,size,_,ptrs)) \
	SPEC_COMPACTING_INFO(CAT4(_ScanLink_,size,_,ptrs),			\
			     CAT2(_PRStart_,ptrs),				\
			     CAT2(_ScanMove_,size),CAT2(_PRIn_,ptrs))		\
	}

# line 880 "SMInfoTables.lh"

#if defined(PAR) || defined(GRAN)
# define SELECT_ITBL(infolbl,entry_code,upd_code,liveness,tag,size,ptrs,localness,entry_localness,select_word_i,kind,descr,type) \
    entry_localness(CAT2(RBH_,entry_code));    	\
    localness W_ infolbl[];			\
    localness W_ CAT2(RBH_,infolbl)[] = {	\
        (W_) CAT2(RBH_,entry_code)		\
	,(W_) INFO_OTHER_TAG			\
	,(W_) MK_REP_REF(Spec_RBH,size,ptrs)	\
	INCLUDE_PROFILING_INFO(RBH)		\
	INCLUDE_SPEC_PADDING			\
	INCLUDE_RBH_INFO(infolbl)		\
	};					\
    STGFUN(CAT2(RBH_,entry_code)) { JMP_(RBH_entry); }\
    CAT_DECLARE(infolbl,kind,descr,type) 	\
    entry_localness(entry_code);	    	\
    localness W_ infolbl[] = {			\
        (W_) entry_code				\
	,(W_) tag				\
	,(W_) MK_REP_REF(Select,,select_word_i) \
	INCLUDE_PROFILING_INFO(infolbl)		\
	INCLUDE_SPEC_PADDING			\
	INCLUDE_RBH_INFO(CAT2(RBH_,infolbl))	\
	}					\

#else

# define SELECT_ITBL(infolbl,entry_code,upd_code,liveness,tag,size,ptrs,localness,entry_localness,select_word_i,kind,descr,type) \
    CAT_DECLARE(infolbl,kind,descr,type) 	\
    entry_localness(entry_code);	    	\
    localness W_ infolbl[] = {			\
        (W_) entry_code				\
	,(W_) tag				\
	,(W_) MK_REP_REF(Select,,select_word_i) \
	INCLUDE_PROFILING_INFO(infolbl)		\
	}

#endif

MAYBE_DECLARE_RTBL(Select,,0)
MAYBE_DECLARE_RTBL(Select,,1)
MAYBE_DECLARE_RTBL(Select,,2)
MAYBE_DECLARE_RTBL(Select,,3)
MAYBE_DECLARE_RTBL(Select,,4)
MAYBE_DECLARE_RTBL(Select,,5)
MAYBE_DECLARE_RTBL(Select,,6)
MAYBE_DECLARE_RTBL(Select,,7)
MAYBE_DECLARE_RTBL(Select,,8)
MAYBE_DECLARE_RTBL(Select,,9)
MAYBE_DECLARE_RTBL(Select,,10)
MAYBE_DECLARE_RTBL(Select,,11)
MAYBE_DECLARE_RTBL(Select,,12)

#define SELECT_RTBL(size,ptrs,select_word_i)					\
    const W_ MK_REP_LBL(Select,,select_word_i)[] = {				\
	INCLUDE_TYPE_INFO(SPEC_U)						\
	INCLUDE_SIZE_INFO(size,ptrs)						\
	INCLUDE_PAR_INFO							\
	INCLUDE_COPYING_INFO(CAT2(_EvacuateSelector_,select_word_i),		\
			     CAT4(_Scavenge_,size,_,ptrs)) 			\
	SPEC_COMPACTING_INFO(CAT4(_ScanLink_,size,_,ptrs),			\
			     CAT2(_PRStartSelector_,select_word_i),		\
                             CAT2(_ScanMove_,size),				\
			     CAT2(_PRIn_,ptrs))					\
	}

# line 961 "SMInfoTables.lh"

#define GEN_N_ITBL(infolbl,entry_code,upd_code,liveness,tag,size,ptrs,localness,entry_localness,kind,descr,type) \
    CAT_DECLARE(infolbl,kind,descr,type) 	\
    entry_localness(entry_code);	    	\
    localness W_ infolbl[] = {			\
        (W_) entry_code				\
	,(W_) tag				\
	,(W_) MK_REP_REF(Gen_N,,)		\
	INCLUDE_PROFILING_INFO(infolbl)		\
	INCLUDE_UPDATE_INFO(upd_code,liveness)	\
	INCLUDE_GEN_INFO(size,ptrs)		\
	}

MAYBE_DECLARE_RTBL(Gen_N,,)

#define GEN_N_RTBL()								\
    const W_ MK_REP_LBL(Gen_N,,)[] = {						\
	INCLUDE_TYPE_INFO(GEN_N)						\
	INCLUDE_SIZE_INFO(INFO_UNUSED,INFO_UNUSED) 	\
	INCLUDE_PAR_INFO							\
	INCLUDE_COPYING_INFO(_Evacuate_S,_Scavenge_S_N)				\
	INCLUDE_COMPACTING_INFO(_ScanLink_S_N,_PRStart_N,_ScanMove_S,_PRIn_I)	\
	}

#define GEN_S_ITBL(infolbl,entry_code,upd_code,liveness,tag,size,ptrs,localness,entry_localness,kind,descr,type) \
    CAT_DECLARE(infolbl,kind,descr,type) 	\
    entry_localness(entry_code);	    	\
    localness W_ infolbl[] = {			\
        (W_) entry_code				\
	,(W_) tag				\
	,(W_) MK_REP_REF(Gen_S,,)		\
	INCLUDE_PROFILING_INFO(infolbl)		\
	INCLUDE_UPDATE_INFO(upd_code,liveness)	\
	INCLUDE_GEN_INFO(size,ptrs)		\
	}

MAYBE_DECLARE_RTBL(Gen_S,,)

#define GEN_S_RTBL()								\
    const W_ MK_REP_LBL(Gen_S,,)[] = {						\
	INCLUDE_TYPE_INFO(GEN_S)						\
	INCLUDE_SIZE_INFO(INFO_UNUSED,INFO_UNUSED) 	\
	INCLUDE_PAR_INFO							\
	INCLUDE_COPYING_INFO(_Evacuate_S,_Scavenge_S_N)				\
	INCLUDE_COMPACTING_INFO(_ScanLink_S_N,_PRStart_N,_ScanMove_S,_PRIn_I)	\
	}

#if defined(PAR) || defined(GRAN)
# define GEN_U_ITBL(infolbl,entry_code,upd_code,liveness,tag,size,ptrs,localness,entry_localness,kind,descr,type) \
    entry_localness(CAT2(RBH_,entry_code));    	\
    localness W_ infolbl[];			\
    localness W_ CAT2(RBH_,infolbl)[] = {	\
        (W_) CAT2(RBH_,entry_code)		\
	,(W_) INFO_OTHER_TAG			\
	,(W_) MK_REP_REF(Gen_RBH,,)	    	\
	INCLUDE_PROFILING_INFO(RBH)		\
	INCLUDE_UPDATE_INFO(INFO_UNUSED,INFO_UNUSED)	\
	INCLUDE_GEN_INFO(size,ptrs)		\
	INCLUDE_RBH_INFO(infolbl)		\
	};					\
    STGFUN(CAT2(RBH_,entry_code)) { JMP_(RBH_entry); }\
    CAT_DECLARE(infolbl,kind,descr,type) 	\
    entry_localness(entry_code);	    	\
    localness W_ infolbl[] = {			\
        (W_) entry_code				\
	,(W_) tag				\
	,(W_) MK_REP_REF(Gen_U,,)		\
	INCLUDE_PROFILING_INFO(infolbl)		\
	INCLUDE_UPDATE_INFO(INFO_UNUSED,INFO_UNUSED)	\
	INCLUDE_GEN_INFO(size,ptrs)		\
	INCLUDE_RBH_INFO(CAT2(RBH_,infolbl))	\
	}

MAYBE_DECLARE_RTBL(Gen_RBH,,)

# define GEN_RBH_RTBL()								\
    const W_ MK_REP_LBL(Gen_RBH,,)[] = {					\
	INCLUDE_TYPE_INFO(GEN_RBH)						\
	INCLUDE_SIZE_INFO(INFO_UNUSED,INFO_UNUSED) 	\
	INCLUDE_PAR_INFO							\
	INCLUDE_COPYING_INFO(_Evacuate_RBH_S,_Scavenge_RBH_N)			\
	INCLUDE_COMPACTING_INFO(_ScanLink_RBH_N,_PRStart_RBH_N,_ScanMove_RBH_S,_PRIn_RBH_I)	\
	}

#else

# define GEN_U_ITBL(infolbl,entry_code,upd_code,liveness,tag,size,ptrs,localness,entry_localness,kind,descr,type) \
    CAT_DECLARE(infolbl,kind,descr,type) 	\
    entry_localness(entry_code);	    	\
    localness W_ infolbl[] = {			\
        (W_) entry_code				\
	,(W_) tag				\
	,(W_) MK_REP_REF(Gen_U,,)		\
	INCLUDE_PROFILING_INFO(infolbl)		\
	INCLUDE_UPDATE_INFO(INFO_UNUSED,INFO_UNUSED)	\
	INCLUDE_GEN_INFO(size,ptrs)		\
	}
#endif

MAYBE_DECLARE_RTBL(Gen_U,,)

#define GEN_U_RTBL()								\
    const W_ MK_REP_LBL(Gen_U,,)[] = {						\
	INCLUDE_TYPE_INFO(GEN_U)						\
	INCLUDE_SIZE_INFO(INFO_UNUSED,INFO_UNUSED) 	\
	INCLUDE_PAR_INFO							\
	INCLUDE_COPYING_INFO(_Evacuate_S,_Scavenge_S_N)				\
	INCLUDE_COMPACTING_INFO(_ScanLink_S_N,_PRStart_N,_ScanMove_S,_PRIn_I)	\
	}

# line 1086 "SMInfoTables.lh"

#define DYN_ITBL(infolbl,entry_code,upd_code,liveness,tag,size,ptrs,localness,entry_localness,kind,descr,type)  \
    CAT_DECLARE(infolbl,kind,descr,type) 	\
    entry_localness(entry_code);	    	\
    localness W_ infolbl[] = {			\
        (W_) entry_code				\
	,(W_) tag				\
	,(W_) MK_REP_LBL(Dyn,,)			\
	INCLUDE_PROFILING_INFO(infolbl)		\
	}

MAYBE_DECLARE_RTBL(Dyn,,)

#define DYN_RTBL()							\
    const W_ MK_REP_LBL(Dyn,,)[] = {					\
	INCLUDE_TYPE_INFO(DYN)						\
	INCLUDE_SIZE_INFO(INFO_UNUSED,INFO_UNUSED) 	\
	INCLUDE_PAR_INFO						\
	INCLUDE_COPYING_INFO(_Evacuate_Dyn,_Scavenge_Dyn)		\
	INCLUDE_COMPACTING_INFO(_ScanLink_Dyn,_PRStart_Dyn,_ScanMove_Dyn,_PRIn_I_Dyn) \
	}

# line 1120 "SMInfoTables.lh"

#define TUPLE_ITBL(infolbl,entry_code,upd_code,liveness,tag,size,ptrs,localness,entry_localness,kind,descr,type)  \
    CAT_DECLARE(infolbl,kind,descr,type) 	\
    entry_localness(entry_code);	    	\
    localness W_ infolbl[] = {			\
        (W_) entry_code				\
	,(W_) tag				\
	,(W_) MK_REP_REF(Tuple,,)		\
	INCLUDE_PROFILING_INFO(infolbl)		\
	}

MAYBE_DECLARE_RTBL(Tuple,,)

#define TUPLE_RTBL() \
    const W_ MK_REP_LBL(Tuple,,)[] = { \
	INCLUDE_TYPE_INFO(TUPLE)					\
	INCLUDE_SIZE_INFO(INFO_UNUSED,INFO_UNUSED) 	\
	INCLUDE_PAR_INFO						\
	INCLUDE_COPYING_INFO(_Evacuate_Tuple,_Scavenge_Tuple) \
	INCLUDE_COMPACTING_INFO(_ScanLink_Tuple,_PRStart_Tuple,_ScanMove_Tuple,_PRIn_I_Tuple) \
	}

#define DATA_ITBL(infolbl,entry_code,upd_code,liveness,tag,size,ptrs,localness,entry_localness,kind,descr,type)  \
    CAT_DECLARE(infolbl,kind,descr,type) 	\
    entry_localness(entry_code);	    	\
    localness W_ infolbl[] = {			\
        (W_) entry_code				\
	,(W_) tag				\
	,(W_) MK_REP_REF(Data,,)		\
	INCLUDE_PROFILING_INFO(infolbl)		\
	}

MAYBE_DECLARE_RTBL(Data,,)

#define DATA_RTBL() 			\
    const W_ MK_REP_LBL(Data,,)[] = {	\
	INCLUDE_TYPE_INFO(DATA)		\
	INCLUDE_SIZE_INFO(INFO_UNUSED,INFO_UNUSED)  \
	INCLUDE_PAR_INFO		 \
	INCLUDE_COPYING_INFO(_Evacuate_Data,_Scavenge_Data) \
	INCLUDE_COMPACTING_INFO(_ScanLink_Data,_PRStart_Data,_ScanMove_Data,_PRIn_Error) \
    }


#ifndef COMPILING_GHC
EXTDATA_RO(ArrayOfData_info);
#endif
# line 1179 "SMInfoTables.lh"

#if defined(GC_MUT_REQUIRED)

# define MUTUPLE_ITBL(infolbl,entry_code,upd_code,liveness,tag,size,ptrs,localness,entry_localness,kind,descr,type)  \
    CAT_DECLARE(infolbl,kind,descr,type) 	\
    entry_localness(entry_code);	    	\
    localness W_ infolbl[] = {			\
        (W_) entry_code				\
	,(W_) tag				\
	,(W_) MK_REP_REF(MuTuple,,)		\
	INCLUDE_PROFILING_INFO(infolbl)		\
	}

MAYBE_DECLARE_RTBL(MuTuple,,)

# define MUTUPLE_RTBL()				\
    const W_ MK_REP_LBL(MuTuple,,)[] = {	\
	INCLUDE_TYPE_INFO(MUTUPLE)		\
	INCLUDE_SIZE_INFO(INFO_UNUSED,INFO_UNUSED)  \
	INCLUDE_PAR_INFO			 \
	INCLUDE_COPYING_INFO(_Evacuate_MuTuple,_Scavenge_MuTuple) \
	INCLUDE_COMPACTING_INFO(_ScanLink_MuTuple,_PRStart_MuTuple,_ScanMove_MuTuple,_PRIn_I_MuTuple) \
	}

# define IMMUTUPLE_ITBL(infolbl,entry_code,upd_code,liveness,tag,size,ptrs,localness,entry_localness,kind,descr,type)  \
    CAT_DECLARE(infolbl,kind,descr,type) 	\
    entry_localness(entry_code);	    	\
    localness W_ infolbl[] = {			\
        (W_) entry_code				\
	,(W_) tag				\
	,(W_) MK_REP_REF(ImmuTuple,,)		\
	INCLUDE_PROFILING_INFO(infolbl)		\
	}

MAYBE_DECLARE_RTBL(ImmuTuple,,)

# define IMMUTUPLE_RTBL() \
    const W_ MK_REP_LBL(ImmuTuple,,)[] = {  \
	INCLUDE_TYPE_INFO(IMMUTUPLE)	    \
	INCLUDE_SIZE_INFO(INFO_UNUSED,INFO_UNUSED)  \
	INCLUDE_PAR_INFO			 \
	INCLUDE_COPYING_INFO(_Evacuate_MuTuple,_Scavenge_MuTuple) \
	INCLUDE_COMPACTING_INFO(_ScanLink_MuTuple,_PRStart_MuTuple,_ScanMove_ImmuTuple,_PRIn_I_MuTuple) \
    }
  
#else   

# define MUTUPLE_ITBL(infolbl,entry_code,upd_code,liveness,tag,size,ptrs,localness,entry_localness,kind,descr,type) \
	TUPLE_ITBL(infolbl,entry_code,upd_code,liveness,tag,size,ptrs,localness,entry_localness,kind,descr,type)
# define IMMUTUPLE_ITBL(infolbl,entry_code,upd_code,liveness,tag,size,ptrs,localness,entry_localness,kind,descr,type) \
	TUPLE_ITBL(infolbl,entry_code,upd_code,liveness,tag,size,ptrs,localness,entry_localness,kind,descr,type)

# define MUTUPLE_RTBL()
# define IMMUTUPLE_RTBL()
#endif


#ifndef COMPILING_GHC
EXTDATA_RO(ArrayOfPtrs_info);
EXTDATA_RO(ImMutArrayOfPtrs_info);
EXTDATA_RO(EmptySVar_info);
EXTDATA_RO(FullSVar_info);
#endif
# line 1255 "SMInfoTables.lh"
#define STATIC_ITBL(infolbl,entry_code,upd_code,liveness,tag,size,ptrs,localness,entry_localness,kind,descr,type) \
    CAT_DECLARE(infolbl,kind,descr,type) 	\
    entry_localness(entry_code);	    	\
    localness W_ infolbl[] = {			\
        (W_) entry_code				\
	,(W_) tag				\
	,(W_) MK_REP_REF(Static,,)		\
	INCLUDE_PROFILING_INFO(infolbl)		\
	INCLUDE_UPDATE_INFO(upd_code,liveness)	\
	INCLUDE_STATIC_INFO(size,ptrs)		\
	}

MAYBE_DECLARE_RTBL(Static,,)

#define STATIC_RTBL() \
    const W_ MK_REP_LBL(Static,,)[] = { \
	INCLUDE_TYPE_INFO(STATIC)	\
	INCLUDE_SIZE_INFO(INFO_UNUSED,INFO_UNUSED)  \
	INCLUDE_PAR_INFO		 \
	INCLUDE_COPYING_INFO(_Evacuate_Static,_Dummy_Static_entry) \
	INCLUDE_COMPACTING_INFO(_Dummy_Static_entry,_PRStart_Static, \
				_Dummy_Static_entry,_Dummy_Static_entry) \
	}
# line 1293 "SMInfoTables.lh"
#if !defined(PAR)

# define ForeignObj_ITBL(infolbl,entry_code,upd_code,liveness,tag,size,ptrs,localness,entry_localness,kind,descr,type)  \
    CAT_DECLARE(infolbl,kind,descr,type)	\
    entry_localness(entry_code);		\
    localness W_ infolbl[] = {			\
        (W_) entry_code				\
	,(W_) tag				\
	,(W_) MK_REP_REF(ForeignObj,,)		\
	INCLUDE_PROFILING_INFO(infolbl)		\
    }

MAYBE_DECLARE_RTBL(ForeignObj,,)

# define ForeignObj_RTBL() \
    const W_ MK_REP_LBL(ForeignObj,,)[] = { \
	INCLUDE_TYPE_INFO(INTERNAL)				\
	INCLUDE_SIZE_INFO(ForeignObj_SIZE, 0L)   		\
	INCLUDE_PAR_INFO					\
	INCLUDE_COPYING_INFO(_Evacuate_ForeignObj,_Scavenge_ForeignObj) 	\
	SPEC_COMPACTING_INFO(_ScanLink_ForeignObj,_PRStart_ForeignObj,_ScanMove_ForeignObj,_PRIn_0) \
	}

#endif 
# line 1330 "SMInfoTables.lh"

#define BH_ITBL(infolbl,bh_code,kind,localness,entry_localness) \
    entry_localness(bh_code);			\
    localness W_ infolbl[] = {			\
        (W_) bh_code				\
	,(W_) INFO_OTHER_TAG			\
	,(W_) MK_REP_REF(BH,kind,)		\
	INCLUDE_PROFILING_INFO(BH)		\
    }

MAYBE_DECLARE_RTBL(BH,U,)
MAYBE_DECLARE_RTBL(BH,N,)

#define BH_RTBL(kind)								\
    const W_ MK_REP_LBL(BH,kind,)[] = {						\
	INCLUDE_TYPE_INFO(BH)							\
	INCLUDE_SIZE_INFO(CAT3(BH_,kind,_SIZE),0L)				\
	INCLUDE_PAR_INFO							\
	INCLUDE_COPYING_INFO(CAT2(_Evacuate_BH_,kind),CAT2(_Scavenge_BH_,kind))	\
	INCLUDE_COMPACTING_INFO(CAT2(_ScanLink_BH_,kind),_PRStart_BH,		\
				CAT2(_ScanMove_BH_,kind),_PRIn_Error)		\
    }

# line 1365 "SMInfoTables.lh"

#define IND_ITBL(infolbl,ind_code,localness,entry_localness) \
    CAT_DECLARE(infolbl,INTERNAL_KIND,"IND","IND")	\
    entry_localness(ind_code);		    	    	\
    localness W_ infolbl[] = {				\
        (W_) ind_code					\
	,(W_) INFO_IND_TAG				\
	,(W_) MK_REP_REF(Ind,,)				\
	INCLUDE_PROFILING_INFO(infolbl)			\
	}

MAYBE_DECLARE_RTBL(Ind,,)

#define IND_RTBL()								\
    const W_ MK_REP_LBL(Ind,,)[] = {						\
	INCLUDE_TYPE_INFO(IND)							\
	INCLUDE_SIZE_INFO(MIN_UPD_SIZE,INFO_UNUSED) 	\
	INCLUDE_PAR_INFO			 				\
	INCLUDE_COPYING_INFO(_Evacuate_Ind,_Scavenge_Ind) 			\
	INCLUDE_COMPACTING_INFO(_Dummy_Ind_entry,_PRStart_Ind, 			\
				_Dummy_Ind_entry,_Dummy_Ind_entry) 		\
    }

# line 1396 "SMInfoTables.lh"
#if defined(PROFILING) || defined(TICKY_TICKY)

# define PERM_IND_ITBL(infolbl,ind_code,localness,entry_localness) \
    entry_localness(ind_code);		    	    	\
    CAT_DECLARE(infolbl,INTERNAL_KIND,"IND","IND") 	\
    localness W_ infolbl[] = {				\
        (W_) ind_code					\
	,(W_) INFO_IND_TAG				\
	,(W_) MK_REP_REF(Perm_Ind,,)			\
	INCLUDE_PROFILING_INFO(infolbl)			\
    }

MAYBE_DECLARE_RTBL(Perm_Ind,,)

# define PERM_IND_RTBL()							\
    const W_ MK_REP_LBL(Perm_Ind,,)[] = {					\
	INCLUDE_TYPE_INFO(IND)							\
	INCLUDE_SIZE_INFO(MIN_UPD_SIZE,INFO_UNUSED) 	\
	INCLUDE_PAR_INFO							\
	INCLUDE_COPYING_INFO(_Evacuate_PI,_Scavenge_PI)				\
	SPEC_COMPACTING_INFO(_ScanLink_PI,_PRStart_PI,				\
			     _ScanMove_PI,_PRIn_PI)				\
	}

#else
# define PERM_IND_RTBL()
#endif
# line 1525 "SMInfoTables.lh"

#define CAF_ITBL(infolbl,ind_code,localness,entry_localness) \
    CAT_DECLARE(infolbl,INTERNAL_KIND,"CAF","CAF")	\
    entry_localness(ind_code);				\
    localness W_ infolbl[] = {				\
        (W_) ind_code					\
	,(W_) INFO_IND_TAG				\
	,(W_) MK_REP_REF(Caf,,)				\
	INCLUDE_PROFILING_INFO(infolbl)			\
    }

MAYBE_DECLARE_RTBL(Caf,,)

#define CAF_RTBL()								\
    const W_ MK_REP_LBL(Caf,,)[] = {						\
	INCLUDE_TYPE_INFO(CAF)							\
	INCLUDE_SIZE_INFO(MIN_UPD_SIZE,INFO_UNUSED) 	\
	INCLUDE_PAR_INFO							\
	INCLUDE_COPYING_INFO(_Evacuate_Caf,_Scavenge_Caf)			\
	INCLUDE_COMPACTING_INFO(_Dummy_Caf_entry,_PRStart_Caf,			\
				_Dummy_Caf_entry,_Dummy_Caf_entry)		\
	}
# line 1592 "SMInfoTables.lh"
#define CONST_ITBL(infolbl,closurelbl,entry_code,upd_code,liveness,tag,size,ptrs,localness,entry_localness,kind,descr,type)  \
    CAT_DECLARE(infolbl,kind,descr,type)	\
    entry_localness(entry_code);	    	\
    EXTDATA(closurelbl);			\
    localness W_ infolbl[] = {			\
        (W_) entry_code				\
	,(W_) tag				\
	,(W_) MK_REP_REF(Const,,)		\
	INCLUDE_PROFILING_INFO(infolbl) 	\
	INCLUDE_UPDATE_INFO(upd_code,liveness)	\
	INCLUDE_CONST_INFO(closurelbl)		\
	}

MAYBE_DECLARE_RTBL(Const,,)

#ifdef TICKY_TICKY
    
#define CONST_Scav _Scavenge_0_0
#define CONST_Link _ScanLink_0_0
#define CONST_Move _ScanMove_0
#else
#define CONST_Scav _Dummy_Const_entry
#define CONST_Link _Dummy_Const_entry
#define CONST_Move _Dummy_Const_entry
#endif

#define CONST_RTBL()						\
    const W_ MK_REP_LBL(Const,,)[] = {				\
	INCLUDE_TYPE_INFO(CONST)				\
	INCLUDE_SIZE_INFO(INFO_UNUSED,INFO_UNUSED)		\
	INCLUDE_PAR_INFO					\
	INCLUDE_COPYING_INFO(_Evacuate_Const,CONST_Scav)	\
	INCLUDE_COMPACTING_INFO(CONST_Link,_PRStart_Const,	\
				CONST_Move,_Dummy_Const_entry)	\
    }
# line 1655 "SMInfoTables.lh"
#define CHARLIKE_ITBL(infolbl,entry_code,upd_code,liveness,tag,size,ptrs,localness,entry_localness,kind,descr,type)  \
    CAT_DECLARE(infolbl,kind,descr,type) 	\
    entry_localness(entry_code);	    	\
    localness W_ infolbl[] = {			\
        (W_) entry_code				\
	,(W_) INFO_FIRST_TAG			\
	,(W_) MK_REP_REF(CharLike,,)		\
	INCLUDE_PROFILING_INFO(infolbl)		\
	INCLUDE_UPDATE_INFO(upd_code,liveness)	\
	}

MAYBE_DECLARE_RTBL(CharLike,,)

#ifdef TICKY_TICKY
    
#define CHARLIKE_Scav _Scavenge_1_0
#define CHARLIKE_Link _ScanLink_1_0
#define CHARLIKE_Move _ScanMove_1
#else
#define CHARLIKE_Scav _Dummy_CharLike_entry
#define CHARLIKE_Link _Dummy_CharLike_entry
#define CHARLIKE_Move _Dummy_CharLike_entry
#endif

#define CHARLIKE_RTBL()							\
    const W_ MK_REP_LBL(CharLike,,)[] = {				\
	INCLUDE_TYPE_INFO(CHARLIKE)					\
	INCLUDE_SIZE_INFO(INFO_UNUSED,INFO_UNUSED)			\
	INCLUDE_PAR_INFO						\
	INCLUDE_COPYING_INFO(_Evacuate_CharLike,CHARLIKE_Scav)		\
	INCLUDE_COMPACTING_INFO(CHARLIKE_Link,_PRStart_CharLike,	\
				CHARLIKE_Move,_PRIn_Error)		\
	}
# line 1696 "SMInfoTables.lh"
#define INTLIKE_ITBL(infolbl,entry_code,upd_code,liveness,tag,size,ptrs,localness,entry_localness,kind,descr,type)  \
    CAT_DECLARE(infolbl,kind,descr,type) 	\
    entry_localness(entry_code);		\
    localness W_ infolbl[] = {			\
        (W_) entry_code				\
	,(W_) INFO_FIRST_TAG			\
	,(W_) MK_REP_REF(IntLike,,)		\
	INCLUDE_PROFILING_INFO(infolbl)		\
	INCLUDE_UPDATE_INFO(upd_code,liveness)	\
    }

MAYBE_DECLARE_RTBL(IntLike,,)

#define INTLIKE_RTBL()							\
    const W_ MK_REP_LBL(IntLike,,)[] = {				\
	INCLUDE_TYPE_INFO(INTLIKE)					\
	INCLUDE_SIZE_INFO(INFO_UNUSED,INFO_UNUSED)			\
	INCLUDE_PAR_INFO				  		\
	INCLUDE_COPYING_INFO(_Evacuate_IntLike,_Scavenge_1_0) 		\
	INCLUDE_COMPACTING_INFO(_ScanLink_1_0,_PRStart_IntLike,		\
				_ScanMove_1,_PRIn_Error) 		\
    }
# line 1733 "SMInfoTables.lh"

#define INREGS_ITBL(infolbl,entry_code,upd_code,liveness,tag,size,ptrs,localness,entry_localness,kind,descr,type)  \
    localness W_ infolbl[] = {			\
        (W_) INFO_UNUSED			\
	,(W_) tag				\
	,(W_) INFO_UNUSED			\
	INREGS_PROFILING_INFO			\
	INCLUDE_UPDATE_INFO(upd_code,liveness)	\
    }


#ifndef COMPILING_GHC
EXTDATA_RO(Bool_itblvtbl);
#endif

# line 1752 "SMInfoTables.lh"
#endif 
