# line 21 "SMinterface.lh"
#ifndef SMinterface_H
#define SMinterface_H
# line 43 "SMinterface.lh"
typedef struct {
    P_ hp;	
    P_ hplim;   

    I_ rootno; 
    P_ *roots;  
    P_ CAFlist; 

#if defined(GCap) || defined(GCgn)
    P_ OldMutables; 
    P_ OldLim;      
#endif

#ifndef PAR
    P_ ForeignObjList;     

#if defined(GCap) || defined(GCgn)
    P_ OldForeignObjList;  
#endif

    P_ StablePointerTable;
	
#endif 

    I_ hardHpOverflowSize;  


} smInfo;

extern smInfo StorageMgrInfo;

# line 80 "SMinterface.lh"
#ifndef CONCURRENT
# define SM_MAXROOTS 8		
#else
# ifndef PAR
#   ifdef GRAN
#    define SM_MAXROOTS (10 + (MAX_PROC*2) + 2 )
		     
#   else
#     define SM_MAXROOTS 5      
#   endif
# else
#  define SM_MAXROOTS 6         
# endif
#endif
# line 98 "SMinterface.lh"
IF_RTS(void    initSM	    (STG_NO_ARGS);)
IF_RTS(rtsBool exitSM	    PROTO((smInfo *sm));)
IF_RTS(rtsBool initStacks   PROTO((smInfo *sm));)
IF_RTS(rtsBool initHeap	    PROTO((smInfo *sm));)
#ifdef CONCURRENT
IF_RTS(rtsBool initThreadPools (STG_NO_ARGS);)
#endif
#ifdef PAR
IF_RTS(void init_gr_profiling PROTO((int, char **, int, char **));)
#endif

I_ collectHeap	    PROTO((W_ reqsize, smInfo *sm, rtsBool do_full_collection));

IF_RTS(void unmapMiddleStackPage PROTO((char *, int));) 

#if defined(PROFILING) || defined(PAR)
IF_RTS(void handle_tick_serial(STG_NO_ARGS);)
IF_RTS(void handle_tick_noserial(STG_NO_ARGS);)
#endif



StgDouble usertime(STG_NO_ARGS);
StgDouble elapsedtime(STG_NO_ARGS);
void	  start_time(STG_NO_ARGS);
void	  end_init(STG_NO_ARGS);

#ifdef PAR
void EvacuateLocalGAs PROTO((rtsBool full));
void RebuildGAtables PROTO((rtsBool full));
#endif

# line 207 "SMinterface.lh"
#define GC_HARD_LIMIT_EXCEEDED 0
#define GC_SOFT_LIMIT_EXCEEDED 1
#define GC_SUCCESS 2
# line 435 "SMinterface.lh"
#if 1 

typedef struct {
    PP_	botA;	
    P_		botB;	
} stackData;

extern stackData stackInfo;

#endif 
# line 457 "SMinterface.lh"
#if   defined(GC2s)
#define _INFO_COPYING

#else
#if defined(GC1s)
#define _INFO_COMPACTING
#define _INFO_MARKING

#else
#if defined(GCdu) || defined (GCap) || defined (GCgn)
#define _INFO_COPYING
#define _INFO_COMPACTING
#define _INFO_MARKING

#else

#endif
#endif
#endif
# line 535 "SMinterface.lh"
#endif 
