# line 8 "SMupdate.lh"
#ifndef SMUPDATE_H
#define SMUPDATE_H
# line 105 "SMupdate.lh"
I_ SqueezeUpdateFrames PROTO((P_, P_, P_));

EXTDATA_RO(vtbl_StdUpdFrame);
EXTFUN(StdUpdFrameDirectReturn);

EXTFUN(StdErrorCode); 
EXTFUN(UpdErr);
EXTFUN(IndUpdRetV0);
EXTFUN(IndUpdRetV1);
EXTFUN(IndUpdRetV2);
EXTFUN(IndUpdRetV3);
EXTFUN(IndUpdRetV4);
EXTFUN(IndUpdRetV5);
EXTFUN(IndUpdRetV6);
EXTFUN(IndUpdRetV7);
EXTFUN(IndUpdRetDir);






#ifdef __STG_REV_TBLS__
#define RVREL(offset) (-(offset)-1)
#define DIRECT(target) (target)
#define UNVEC(direct,vector) direct
#else
#define RVREL(offset) (offset)
#define DIRECT(target) (*(target))
#define UNVEC(direct,vector) vector
#endif

#ifdef CONCURRENT

extern const W_ vtbl_Underflow[];
EXTFUN(UnderflowDirectReturn);
EXTFUN(UnderflowVect0);
EXTFUN(UnderflowVect1);
EXTFUN(UnderflowVect2);
EXTFUN(UnderflowVect3);
EXTFUN(UnderflowVect4);
EXTFUN(UnderflowVect5);
EXTFUN(UnderflowVect6);
EXTFUN(UnderflowVect7);
EXTFUN(StackUnderflowEnterNode);
EXTFUN(CommonUnderflow);
EXTFUN(PrimUnderflow);
#endif	



#define PUSH_RET(frame, rv)	    	(frame)[BREL(UF_RET)] = (W_)(rv)
#define PUSH_UPDATEE(frame, updatee)	(frame)[BREL(UF_UPDATEE)] = (W_)(updatee)
#define PUSH_SuB(frame, sub)		(frame)[BREL(UF_SUB)] = (W_)(sub)
#define PUSH_SuA(frame, sua)	    	(frame)[BREL(UF_SUA)] = (W_)(sua)

#if defined(PROFILING)
#define	PUSH_STD_CCC(frame) (frame)[BREL(UF_COST_CENTRE)] = (W_)(CCC)
#else
#define	PUSH_STD_CCC(frame)
#endif



#define GRAB_RET(frame)	    	((void *)((frame)[BREL(UF_RET)]))
#define GRAB_SuB(frame)     	((P_)((frame)[BREL(UF_SUB)]))
#define GRAB_SuA(frame)     	((PP_)((frame)[BREL(UF_SUA)]))
#define GRAB_UPDATEE(frame) 	((P_)((frame)[BREL(UF_UPDATEE)]))
#define GRAB_COST_CENTRE(frame)	((CostCentre)((frame)[BREL(UF_COST_CENTRE)]))

#define PUSH_STD_UPD_FRAME(target, SpA_offset, SpB_offset)	\
    do {							\
    	P_ __frame;					  	\
	UPDF_STD_PUSHED();			\
	__frame = SpB - BREL(SpB_offset + STD_UF_SIZE);		\
    	PUSH_RET(__frame, RetReg);  	    	    	    	\
	PUSH_SuB(__frame, SuB); 		    	    	\
	PUSH_SuA(__frame, SuA); 		    	    	\
	PUSH_UPDATEE(__frame, target);	    	    	    	\
	PUSH_STD_CCC(__frame);				    	\
	SuB = __frame;					    	\
	SuA = SpA - AREL(SpA_offset);				\
    } while(0)

#define POP_STD_UPD_FRAME() 	    	    	    	    	\
    do {    	    	    	    	    	    	    	\
    	RetReg = GRAB_RET(SpB);	    	    	    	    	\
        SuB = GRAB_SuB(SpB);    	    	    	    	\
        SuA = GRAB_SuA(SpB);    	    	    	    	\
        SpB += BREL(STD_UF_SIZE);   	    	    	    	\
    } while(0);

# line 212 "SMupdate.lh"
EXTDATA_RO(BH_UPD_info);
EXTFUN(BH_UPD_entry);
EXTDATA_RO(BH_SINGLE_info);
EXTFUN(BH_SINGLE_entry);

#define UPD_BH(heapptr,infolbl)		INFO_PTR(heapptr) = (W_) infolbl
# line 238 "SMupdate.lh"
#if defined(CONCURRENT)
#define UPD_BH_UPDATABLE(heapptr)	UPD_BH(heapptr,BH_UPD_info)
#else
#define UPD_BH_UPDATABLE(heapptr)	
#endif

#define UPD_BH_SINGLE_ENTRY(heapptr) 	UPD_BH(heapptr,BH_SINGLE_info)
					
# line 272 "SMupdate.lh"
EXTDATA_RO(Caf_info);
EXTFUN(Caf_entry);

#define UPD_CAF(cafptr, bhptr)					\
  do {								\
  SET_INFO_PTR(cafptr, Caf_info);				\
  IND_CLOSURE_PTR(cafptr)  = (W_) (bhptr);			\
  IND_CLOSURE_LINK(cafptr) = (W_) StorageMgrInfo.CAFlist;	\
  StorageMgrInfo.CAFlist   = (P_) (cafptr);			\
  } while(0)
# line 329 "SMupdate.lh"
EXTDATA_RO(PAP_info);
EXTFUN(PAP_entry);
EXTFUN(UpdatePAP);
# line 341 "SMupdate.lh"
#ifdef CONCURRENT





#define ALREADY_LINKED(closure)	\
    (IS_MUTABLE(INFO_PTR(closure)) && MUT_LINK(closure) != MUT_NOT_LINKED)

# if defined(GRAN)
extern P_ AwakenBlockingQueue PROTO((P_));
# else
extern void AwakenBlockingQueue PROTO((P_));
# endif

# ifdef MAIN_REG_MAP
#  define AWAKEN_BQ(updatee)						\
do { if (IS_BQ_CLOSURE(updatee))					\
 STGCALL1(void,(void *, P_), AwakenBlockingQueue, (P_) BQ_ENTRIES(updatee)); \
} while(0);
# endif

# ifdef NULL_REG_MAP
#  define AWAKEN_BQ(updatee)			\
do { if (IS_BQ_CLOSURE(updatee))		\
 AwakenBlockingQueue((P_)BQ_ENTRIES(updatee));	\
} while(0);
# endif

# define AWAKEN_INPLACE_BQ()

#else 

# define ALREADY_LINKED(closure) 0 

# define AWAKEN_BQ(updatee)
# define AWAKEN_INPLACE_BQ()

#endif 

EXTDATA_RO(Ind_info);
EXTFUN(Ind_entry);
#ifndef TICKY_TICKY
# define Ind_info_TO_USE Ind_info
#else
EXTDATA_RO(Perm_Ind_info);
EXTFUN(Perm_Ind_entry);

# define Ind_info_TO_USE ((AllFlags.doUpdEntryCounts) ? Perm_Ind_info : Ind_info)
#endif

#if defined(GC2s) || defined(GC1s) || defined(GCdu)

#define INPLACE_UPD_HDR(closure,infolbl,cc,size,ptrs) 		\
	UPD_FIXED_HDR(closure,infolbl,cc)

#define UPD_IND(updclosure, heapptr)   				\
	UPDATED_SET_UPDATED(updclosure); 		\
    	AWAKEN_BQ(updclosure);					\
	SET_INFO_PTR(updclosure, Ind_info_TO_USE);		\
	IND_CLOSURE_PTR(updclosure) = (W_)(heapptr)

#define UPD_INPLACE_NOPTRS(livemask)				\
	UPDATED_SET_UPDATED(Node); 			\
	AWAKEN_BQ(Node);

#define UPD_INPLACE_PTRS(livemask)				\
	UPDATED_SET_UPDATED(Node); 			\
	AWAKEN_BQ(Node);
# line 423 "SMupdate.lh"
#else 
# if defined(GCap) || defined(GCgn)


#define INPLACE_UPD_HDR(closure,infolbl,cc,size,ptrs) 			\
  UPD_FIXED_HDR(closure,infolbl,cc)


#define UPD_IND(updclosure, heapptr)					\
{ UPDATED_SET_UPDATED(updclosure); 				\
  if ( ((P_)(updclosure)) > StorageMgrInfo.OldLim ) {			\
      UPD_NEW_IND(); 						\
  } else { 								\
      UPD_OLD_IND();                                  		\
      if(!ALREADY_LINKED(updclosure)) {					\
          MUT_LINK(updclosure) = (W_) StorageMgrInfo.OldMutables;	\
          StorageMgrInfo.OldMutables = (P_) (updclosure);		\
      }	    	    	    	    	    	    	    		\
  }									\
  AWAKEN_BQ(updclosure);						\
  SET_INFO_PTR(updclosure, Ind_info_TO_USE);				\
  IND_CLOSURE_PTR(updclosure) = (W_)(heapptr);	    	    		\
}





#define UPD_INPLACE_NOPTRS(live_regs_mask)	  			\
  UPDATED_SET_UPDATED(Node); 				\
  if ( Node > StorageMgrInfo.OldLim) { 					\
      UPD_NEW_IN_PLACE_NOPTRS();                 		\
      AWAKEN_BQ(Node);							\
  } else {								\
      UPD_OLD_IN_PLACE_NOPTRS(); 				\
      if(ALREADY_LINKED(Node)) {					\
          				\
          HEAP_CHK(live_regs_mask, _FHS+MIN_UPD_SIZE, 0);		\
	    			\
          ALLOC_CON(_FHS,1,MIN_UPD_SIZE-1,_FHS+MIN_UPD_SIZE);		\
          CC_ALLOC(CCC,_FHS+MIN_UPD_SIZE,CON_K);			\
	  			\
	  AWAKEN_BQ(Node);						\
          SET_INFO_PTR(Node, Ind_info_TO_USE);				\
          IND_CLOSURE_PTR(Node) = (W_)(Hp-(_FHS+MIN_UPD_SIZE-1));	\
          Node = Hp-(_FHS+MIN_UPD_SIZE-1); 				\
      }									\
  }

#define UPD_INPLACE_PTRS(live_regs_mask)				\
  UPDATED_SET_UPDATED(Node); 				\
  if ( Node > StorageMgrInfo.OldLim) {					\
      UPD_NEW_IN_PLACE_PTRS();                        		\
      AWAKEN_BQ(Node);							\
  } else {								\
      				\
      UPD_OLD_IN_PLACE_PTRS(); 				\
      							\
      HEAP_CHK(live_regs_mask, _FHS+MIN_UPD_SIZE, 0); 			\
				\
      ALLOC_CON(_FHS,1,MIN_UPD_SIZE-1,_FHS+MIN_UPD_SIZE);		\
      CC_ALLOC(CCC,_FHS+MIN_UPD_SIZE,CON_K);				\
									\
      if (!ALREADY_LINKED(Node)) {					\
          MUT_LINK(Node) = (W_) StorageMgrInfo.OldMutables; 		\
          StorageMgrInfo.OldMutables = (P_) (Node);			\
      }	    	    	    	    	    	    			\
      				\
      AWAKEN_BQ(Node);							\
      SET_INFO_PTR(Node, Ind_info_TO_USE);				\
      IND_CLOSURE_PTR(Node) = (W_)(Hp-(_FHS+MIN_UPD_SIZE-1)); 		\
      Node = Hp-(_FHS+MIN_UPD_SIZE-1);					\
  }
# endif 
#endif
# line 516 "SMupdate.lh"
#ifdef GC_MUT_REQUIRED
#define FREEZE_MUT_HDR(freezeclosure,immutinfo) \
	SET_INFO_PTR(freezeclosure, immutinfo)
#else
#define FREEZE_MUT_HDR(freezeclosure,immutinfo) \
	SET_INFO_PTR(freezeclosure, immutinfo)
#endif

#endif 
